// MFCTipsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCTips.h"
#include "MFCTipsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMFCTipsDlg dialog

CMFCTipsDlg::CMFCTipsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCTipsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMFCTipsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
}

void CMFCTipsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFCTipsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFCTipsDlg, CDialog)
	//{{AFX_MSG_MAP(CMFCTipsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_NOTIFY_RANGE(TTN_GETDISPINFO, 0, 0xFFFFFFFF, OnGetDispInfo)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCTipsDlg message handlers

BOOL CMFCTipsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_tt.Create(this);
	m_tt.Activate(TRUE);

	static int ID[] =
	{
		IDC_PICTURE,
		IDC_TEXT,
		IDC_EDIT,
		IDC_COMBO,
		IDC_RADIO1,
		IDC_RADIO2,
		IDC_RADIO3,
		IDC_CHECK,
		IDC_LIST,
		IDC_TREE,
		IDOK,
		IDCANCEL
	};

	static const char *szTipText[] =
	{
		"Picture",
		"Text",
		"Edit",
		"Combo box",
		"Radio button 1",
		"Radio button 2",
		LPSTR_TEXTCALLBACK,
		"Check box",
		"List view",
		"Tree view",
		"OK",
		"Cancel"
	};

	for(int i=0; i<sizeof(ID)/sizeof(int); i++)
		m_tt.AddTool(GetDlgItem(ID[i]), szTipText[i]);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCTipsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCTipsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CMFCTipsDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message >= WM_MOUSEFIRST && pMsg->message <= WM_MOUSELAST)
		m_tt.RelayEvent(pMsg);
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CMFCTipsDlg::OnGetDispInfo(UINT id, NMTTDISPINFO *pNMHDR, LRESULT *pResult)
{
	pNMHDR->lpszText = "Radio button 3";
	*pResult = 0;
}

